From eabf034e0aea5f8c2d4df7c7773085404d5849db Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Jun 09 2015 04:18:33 +0000
Subject: [PATCH 111/254] Add the start of the feed widget.


---

diff --git a/delete-user.py b/delete-user.py
index a533a00..acc2563 100755
--- a/delete-user.py
+++ b/delete-user.py
@@ -19,8 +19,15 @@ print "Looking for account %r" % openid
 user = hubs.models.User.get(session, openid)
 if not user:
     print "No such user %r" % openid
-    sys.exit(1)
+else:
+    print "Found %r.  Deleting." % user
+    session.delete(user)
+
+hub = hubs.models.Hub.get(session, username)
+if not hub:
+    print "No such hub %r" % username
+else:
+    print "Found %r.  Deleting." % hub
+    session.delete(hub)
 
-print "Found %r.  Deleting." % user
-session.delete(user)
 session.commit()
diff --git a/fedmsg.d/fas_credentials.py b/fedmsg.d/fas_credentials.py
new file mode 100644
index 0000000..7f63432
--- /dev/null
+++ b/fedmsg.d/fas_credentials.py
@@ -0,0 +1,19 @@
+import commands
+import getpass
+import os
+
+username = os.environ.get('BODHI_USER')
+if not username:
+    username = raw_input('FAS username: ')
+
+if os.path.exists('/usr/bin/pass'):
+    password = commands.getoutput('pass sys/fas')
+else:
+    password = getpass.getpass('FAS password: ')
+
+config = {
+    'fas_credentials': {
+        'username': username,
+        'password': password,
+    }
+}
diff --git a/fedmsg.d/testconfig.py b/fedmsg.d/testconfig.py
index 464b326..b803bad 100644
--- a/fedmsg.d/testconfig.py
+++ b/fedmsg.d/testconfig.py
@@ -9,4 +9,19 @@ config = {
             "tcp://hub.fedoraproject.org:9940",
         ]
     },
+
+    'datanommer.sqlalchemy.uri': 'postgres://postgres:laksjdf@127.0.0.1/datanommer',
+
+    'fmn.url': 'https://apps.fedoraproject.org/notifications',
+
+    # Some configuration for the rule processors
+    "fmn.rules.utils.use_pkgdb2": False,
+    "fmn.rules.utils.pkgdb2_api_url": "http://209.132.184.188/api/",
+    "fmn.rules.cache": {
+        "backend": "dogpile.cache.dbm",
+        "expiration_time": 300,
+        "arguments": {
+            "filename": "/var/tmp/fmn-cache.dbm",
+        },
+    },
 }
diff --git a/hubs/app.py b/hubs/app.py
index 9ef867d..cbc22e7 100644
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -1,30 +1,52 @@
 import functools
+import logging
 import os
 
 import flask
+import flask.json
 import munch
 
 from flask.ext.openid import OpenID
 
 import hubs.models
 
+import datanommer.models
+
+
 app = flask.Flask(__name__)
 
+logging.basicConfig()
+
 
 # TODO - put this in config so we can migrate to pagure
 # TODO - instead of 'develop', use the version from pkg_resources to figure out
 #        the right tag to link people to.  AGPL ftw.
 SOURCE_URL = 'https://pagure.io/fedora-hubs/blob/develop/f'#/hubs/widgets/badges.py'
 
-
 app.config.from_object('hubs.default_config')
 if 'HUBS_CONFIG' in os.environ:
     app.config.from_envvar('HUBS_CONFIG')
 
 import fedmsg.config
+import fedmsg.meta
 fedmsg_config = fedmsg.config.load_config()
+fedmsg.meta.make_processors(**fedmsg_config)
 
 session = hubs.models.init(fedmsg_config['hubs.sqlalchemy.uri'])
+datanommer.models.init(fedmsg_config['datanommer.sqlalchemy.uri'])
+
+
+class CustomJSONEncoder(flask.json.JSONEncoder):
+    def default(self, o):
+        try:
+            iterable = iter(o)
+        except TypeError:
+            pass
+        else:
+            return list(iterable)
+        return flask.json.JSONEncoder.default(self, o)
+
+app.json_encoder = CustomJSONEncoder
 
 
 @app.route('/')
diff --git a/hubs/consumer.py b/hubs/consumer.py
index 37faff3..81c4717 100644
--- a/hubs/consumer.py
+++ b/hubs/consumer.py
@@ -4,7 +4,9 @@ import collections
 import threading
 import time
 
+import datanommer.models
 import fedmsg.consumers
+import fedmsg.meta
 
 import hubs.models
 
@@ -28,12 +30,17 @@ class CacheInvalidatorExtraordinaire(fedmsg.consumers.FedmsgConsumer):
         if not self.uri:
             raise ValueError('hubs.sqlalchemy.uri must be present')
 
+        fedmsg.meta.make_processors(**self.hub.config)
+
         self.hint_lookup_lock = threading.Lock()
         session = self.make_session()
         with self.hint_lookup_lock:
             self.rebuild_hubs_hint_lookups(session)
         session.commit()  # transaction is committed here
         session.close()
+
+        datanommer.models.init(self.hub.config['datanommer.sqlalchemy.uri'])
+
         log.debug("CacheInvalidatorExtraordinaire initialized")
 
     def make_session(self):
diff --git a/hubs/defaults.py b/hubs/defaults.py
index baa60c6..a26b9de 100644
--- a/hubs/defaults.py
+++ b/hubs/defaults.py
@@ -6,15 +6,16 @@ import hubs.models
 def add_user_widgets(session, hub, username, fullname):
     """ Some defaults for an individual user's hub. """
     widget = hubs.models.Widget(
-        plugin='sticky', index=0, left=True,
+        plugin='fedmsgs', index=0, left=True,
         _config=json.dumps({
-            'text': 'TODO -- Put a fancy graph here...',
+            'username': username,
         }))
     hub.widgets.append(widget)
     widget = hubs.models.Widget(
-        plugin='fedmsgs', index=1, left=True,
+        plugin='feed', index=1, left=True,
         _config=json.dumps({
             'username': username,
+            'fmn_context': 'irc',  # TODO -- make this 'hubs'
         }))
     hub.widgets.append(widget)
 
diff --git a/hubs/models.py b/hubs/models.py
index b129f5d..e4c7fa4 100644
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -99,6 +99,8 @@ class Hub(BASE):
     def by_name(cls, session, name):
         return session.query(cls).filter_by(name=name).first()
 
+    get = by_name
+
     @classmethod
     def create_user_hub(cls, session, username, fullname):
         hub = cls(name=username, summary=fullname)
diff --git a/hubs/validators.py b/hubs/validators.py
index 1079234..cd3d7f6 100644
--- a/hubs/validators.py
+++ b/hubs/validators.py
@@ -13,3 +13,9 @@ def link(session, value):
 def username(session, value):
     openid = 'http://%s.id.fedoraproject.org/' % value
     return not hubs.models.User.by_openid(session, openid) is None
+
+def fmn_context(session, value):
+    # TODO get this from the fedmsg config.
+    return value in [
+        'irc', 'email', 'android', 'desktop', 'hubs',
+    ]
diff --git a/hubs/widgets/__init__.py b/hubs/widgets/__init__.py
index 76c5748..94ffaa2 100644
--- a/hubs/widgets/__init__.py
+++ b/hubs/widgets/__init__.py
@@ -7,6 +7,7 @@ from hubs.widgets import avatar
 from hubs.widgets import badges
 from hubs.widgets import fedmsgs
 from hubs.widgets import fedmsgstats
+from hubs.widgets import feed
 
 from hubs.widgets.workflow import pendingacls
 from hubs.widgets.workflow import updates2stable
@@ -23,6 +24,8 @@ registry = {
     'badges': badges,
     'fedmsgs': fedmsgs,
     'fedmsgstats': fedmsgstats,
+    'feed': feed,
+
     'workflow.pendingacls': pendingacls,
     'workflow.updates2stable': updates2stable,
 }
diff --git a/hubs/widgets/feed.py b/hubs/widgets/feed.py
new file mode 100644
index 0000000..3409ea6
--- /dev/null
+++ b/hubs/widgets/feed.py
@@ -0,0 +1,137 @@
+from __future__ import print_function
+
+from hubs.hinting import hint
+from hubs.widgets.base import argument
+
+import fmn.lib
+import fmn.lib.hinting
+
+import datanommer.models
+
+import arrow
+import jinja2
+import munch
+import requests
+
+import hubs.validators as validators
+
+import datetime
+import logging
+log = logging.getLogger('hubs')
+
+import fedmsg.config
+config = fedmsg.config.load_config()
+fmn_url = config['fmn.url']
+
+
+bazillion = 1000
+paths = fmn.lib.load_rules(root='fmn.rules')
+
+
+template = jinja2.Template("""
+{% for match in matches %}
+<div class="panel panel-default">
+  <div class="panel-body">
+    <div class="media">
+      <div class="media-left">
+        <a href="{{match['link']}} target="_blank">
+          <img class="media-object img-responsive square-32 img-circle" src="{{match['secondary_icon']}}">
+        </a>
+      </div>
+      <div class="media-body">
+        <h4 class="media-heading">{{match['subtitle']}}</h4>
+        {{match['human_time']}}
+      </div>
+    </div>
+  </div>
+</div>
+{% endfor %}
+""")
+
+# No chrome around the feed.
+#from hubs.widgets.chrome import panel
+#chrome = panel()
+
+
+@argument(name="username",
+          default=None,
+          validator=validators.username,
+          help="A FAS username.")
+@argument(name="fmn_context",
+          default="irc", # TODO - Make this 'hubs', or...
+          validator=validators.fmn_context,
+          help="A FMN context.")
+def data(session, widget, username, fmn_context):
+    openid = '%s.id.fedoraproject.org' % username
+    url = '/'.join([fmn_url, 'api', openid, fmn_context])
+    log.info("Getting FMN preferences from %s" % url)
+    print(url)
+    response = requests.get(url)
+    preference = response.json()
+    preference = rehydrate_preferences(preference)
+
+    # The smaller we make this, the faster it is.
+    delta = datetime.timedelta(days=365)
+    end = datetime.datetime.utcnow()
+
+    # We currently only support getting the first page.
+    # The widget framework as currently written doesn't support
+    # multiple pages yet.
+    page = 1
+
+    messages = []
+    for filter in preference['filters']:
+        rules = filter['rules']
+        fmn_hinting = fmn.lib.hinting.gather_hinting(config, rules, paths)
+        total, pages, rows = datanommer.models.Message.grep(
+            start=end-delta,
+            end=end,
+            rows_per_page=bazillion,
+            page=page,
+            order='desc',
+            **fmn_hinting
+        )
+        messages.extend(rows)
+
+    matches = []
+    for message in messages:
+        original = message.__json__()
+        recipients = fmn.lib.recipients(
+            [preference], message.__json__(), paths, config)
+        if recipients:
+            matches.append(original)
+
+    # TODO - sort messages and remove duplicates
+
+    # Smash multiple messages into single ones
+    matches = fedmsg.meta.conglomerate(matches, **config)
+
+    return dict(
+        matches=matches,
+    )
+
+
+@hint()
+def should_invalidate(message, session, widget):
+    # only if a new message would match the FMN filters would this be
+    # invalidated... but that is as expensive as being FMN ourselves.
+    raise NotImplementedError
+
+
+def rehydrate_preferences(preference):
+    for fltr in preference['filters']:
+        fltr['rules'] = [munch.Munch(r) for r in fltr['rules']]
+        for rule in fltr['rules']:
+            code_path = str(rule.code_path)
+            rule.fn = fedmsg.utils.load_class(code_path)
+
+    return preference
+
+def make_result(msg, d):
+    return {
+        'icon': fedmsg.meta.msg2icon(d, **config),
+        'icon2': fedmsg.meta.msg2secondary_icon(d, **config),
+        'subtitle': fedmsg.meta.msg2subtitle(d, **config),
+        'link': fedmsg.meta.msg2link(d, **config),
+        'time': arrow.get(msg.timestamp).humanize(),
+    }
